// StampaCertDER.java

import java.io.*;
import java.security.cert.*;


public class StampaCertDER {
	
	public static void main(String[] args) {
		
		try {

			String nameCert="WISeKeyCommonGlobalRoot.cer";
			String stampa="StampaCertDER_"+nameCert+".txt";

			FileInputStream fis = new FileInputStream(nameCert);
			FileOutputStream fos = new FileOutputStream(stampa);
			PrintWriter pw=new PrintWriter(fos, true);
			
			CertificateFactory cf = CertificateFactory.getInstance("X.509");	
			X509Certificate x509cert = (X509Certificate)cf.generateCertificate(fis);
			
			System.out.println("\nInformazioni reperite dal certificato: "+nameCert+"\n");
			System.out.println("tipo = " + x509cert.getType());
			System.out.println("versione = " + x509cert.getVersion());
			System.out.println("soggetto = " + x509cert.getSubjectDN().getName());
			System.out.println("inizio validit = " + x509cert.getNotBefore());
			System.out.println("fine validit = " + x509cert.getNotAfter());
			System.out.println("numero di serie = " + x509cert.getSerialNumber().toString(16)); //base 16
			System.out.println("emettitore = " + x509cert.getIssuerDN().getName());
			System.out.println("algoritmo di firma = " + x509cert.getSigAlgName());
			System.out.println("algoritmo per la chiave pubblica = " + x509cert.getPublicKey().getAlgorithm());
			
			pw.println("Informazioni reperite dal certificato: "+nameCert);
			pw.println("tipo = " + x509cert.getType());
			pw.println("versione = " + x509cert.getVersion());
			pw.println("soggetto = " + x509cert.getSubjectDN().getName());
			pw.println("inizio validit = " + x509cert.getNotBefore());
			pw.println("fine validit = " + x509cert.getNotAfter());
			pw.println("numero di serie = " + x509cert.getSerialNumber().toString(16)); //base 16
			pw.println("emettitore = " + x509cert.getIssuerDN().getName());
			pw.println("algoritmo di firma = " + x509cert.getSigAlgName());
			pw.println("algoritmo per la chiave pubblica = " + x509cert.getPublicKey().getAlgorithm());
			
			pw.close();
			fos.close();
			fis.close();
			
		}
		
		catch (CertificateException e1) {
			System.out.println("Certificate Exception");
			System.exit(1);
		}
		
		catch (IOException e2) {
			System.out.println("IO Exception");
			System.exit(2);
		}
		
	}
	
}



