// StampaCertPKCS7.java

import java.io.*;
import java.security.cert.*;
import java.util.Collection;
import java.util.Iterator;

public class StampaCertPKCS7 {
	
	public static void main(String[] args) {
		
		try {

			String nameCert="DST Root Cert.p7b";
			String stampa="StampaCertPKCS7_"+nameCert+".txt";
			
			FileInputStream fis = new FileInputStream(nameCert);
			FileOutputStream fos = new FileOutputStream(stampa);
			PrintWriter pw=new PrintWriter(fos,true);
			
			CertificateFactory cf = CertificateFactory.getInstance("X.509");
			Collection c = cf.generateCertificates(fis);
			
			System.out.println("\nInformazioni reperite dal file: "+nameCert+"\n");
			pw.println("Informazioni reperite dal file: "+nameCert);
			Iterator it = c.iterator();
			 
			int j=1;
			while (it.hasNext()) {
				
				System.out.println("certificato N."+j+ ": ");
				X509Certificate x509cert = (X509Certificate)it.next();
				System.out.println(x509cert);
				pw.println(x509cert.toString());
				j++;
				
			}
			
			pw.close();
			fos.close();
			fis.close();
			
		}
	
		catch (CertificateException e1) {
			System.out.println("Certificate Exception");
			System.exit(1);
		}
		
		catch (IOException e2) {
			System.out.println("IO Exception");
			System.exit(2);
		}	
		
	}
	
}
