// VerifyCRL.java

import java.io.*;
import java.security.cert.*;

public class VerifyCRL {
	
	public static void main(String[] args) {
		
		try {
	
			String nameCRL="ecpki.crl";
			String nameCert="WISeKeyCommonGlobalRoot.cer";
			
			FileInputStream inCRL = new FileInputStream(nameCRL);
			FileInputStream inCert = new FileInputStream(nameCert);
			
			CertificateFactory cf = CertificateFactory.getInstance("X.509");
			
			X509CRL crl = (X509CRL)cf.generateCRL(inCRL);
			inCRL.close();
			
			Certificate certificate = cf.generateCertificate(inCert);
			inCert.close();
			
			if (crl.isRevoked(certificate)) System.out.println("Il certificato  stato revocato!");
			else System.out.println("Il certificato "+nameCert+" e' ok!");
			
		}
		
		catch (CertificateException e1) {
			System.out.println("Certificate Exception");
			System.exit(1);
		}
		
		catch (IOException e2) {
			System.out.println("IO Exception");
			System.exit(2);
		}
		
		catch (CRLException e3) {
			System.out.println("CRL Exception");
			System.exit(3);
		}
		
	}
	
}
