// Blowfish.java

import java.security.*;
import javax.crypto.*;
import java.io.*;

public class Blowfish {
	
  	public static void main (String[] args) {

		System.out.println("BLOWFISH");
		String text = "Hello world!";
	    if (args.length == 1) text = args[0];
	    System.out.println("\nTEXT:\n"+text);
    
	    try { 
	    	
		    KeyGenerator keyGenerator = KeyGenerator.getInstance("Blowfish");
		    keyGenerator.init(128);	
		    Key key = keyGenerator.generateKey();
		  
		   	Cipher cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
		    cipher.init(Cipher.ENCRYPT_MODE, key);
		
		    byte[ ] plaintext = text.getBytes("UTF8");
		    System.out.println("\nPLAINTEXT:");
		    for (int i=0;i<plaintext.length;i++) System.out.print(plaintext[i]+" ");
		    
		    byte[ ] ciphertext = cipher.doFinal(plaintext);
			System.out.println("\n\nCIPHERTEXT:");
		    for (int i=0;i<ciphertext.length;i++) System.out.print(ciphertext[i]+" ");
		
		    cipher.init(Cipher.DECRYPT_MODE, key);
			byte[ ] decryptedText = cipher.doFinal(ciphertext);
		    String output = new String(decryptedText,"UTF8");
		    System.out.println("\n\nDECRYPTED TEXT:\n"+output); 
		    
		} 
		
		catch (NoSuchAlgorithmException e1) {		
			System.out.println("Algoritmo non supportato");
			System.exit(1);		
		}
	
		catch (NoSuchPaddingException e2) {		
			System.out.println("Padding non supportato");
			System.exit(2);		
		}
		
		catch (InvalidKeyException e3) {
			System.out.println("Chiave non valida");
			System.exit(3);	
		}
		
		catch (IllegalBlockSizeException e5) {
			System.out.println("Dimensione blocco non corretta");
			System.exit(4);
		}
		
		catch (BadPaddingException e4) {
			System.out.println("Bad Padding");
			System.exit(5);
		}
				
		catch (UnsupportedEncodingException e6) {
			System.out.println("Codifica non supportata");
			System.exit(6);
		}

	}

}
