// CipherStream.java

import java.io.*;
import javax.crypto.*;
import java.security.*;

public class CipherStream
{
	public static void main(String[] args) {
		
		FileInputStream input1;
		FileOutputStream output1;
		
		FileInputStream input2;
		FileOutputStream output2;
		
		CipherInputStream cipherInput;
		CipherOutputStream cipherOutput;
			
		String fileInput;
		String fileOutput1;
		String fileOutput2;
		
		if(args.length==3) {
			fileInput=args[0];
			fileOutput1=args[1];
			fileOutput2=args[2];
		}
		else {
			fileInput="Documento.txt";
			fileOutput1="DocumentoCifrato.txt";
			fileOutput2="DocumentoDecifrato.txt";
		}

		try { 
		
	    	System.out.println("CIPHERSTREAM");
			System.out.println("\nFile chiaro:    "+fileInput);
			System.out.println("File cifrato:   "+fileOutput1);
			System.out.println("File decifrato: "+fileOutput2);

		    KeyGenerator keyGenerator = KeyGenerator.getInstance("TripleDES");
		    keyGenerator.init(168);	// 3 key 56bit (+8bit control)
		    Key key = keyGenerator.generateKey();
		    
		  	input1 = new FileInputStream(fileInput);
			output1 = new  FileOutputStream(fileOutput1) ;
		   	Cipher cipher = Cipher.getInstance("TripleDES/ECB/PKCS5Padding");
		    cipher.init(Cipher.ENCRYPT_MODE, key);
			cipherOutput = new CipherOutputStream (output1, cipher);
			
			int r = 0;
			while ((r=input1.read()) != -1) {
				cipherOutput.write(r);
			}
			
			cipherOutput.close();
			output1.close();
			input1.close();
			
			input2 = new FileInputStream(fileOutput1);
			output2 = new  FileOutputStream(fileOutput2) ;	
			cipher.init(Cipher.DECRYPT_MODE, key);
			cipherInput = new CipherInputStream(input2, cipher);
			
			r = 0;
			while ((r=cipherInput.read()) != -1) {
				output2.write(r);
			}
					
			cipherInput.close();
			output2.close();
			input2.close();	
			
		} 
		
		catch (IOException e1) {
			System.out.println("Eccezione di I/O");
			System.exit(1);
		}
		
		catch (NoSuchAlgorithmException e2) {		
			System.out.println("Algoritmo non supportato");
			System.exit(2);		
		}
	
		catch (NoSuchPaddingException e3) {		
			System.out.println("Padding non supportato");
			System.exit(3);		
		}
		
		catch (InvalidKeyException e4) {
			System.out.println("Chiave non valida");
			System.exit(4);	
		}
		
	}
}

