// RSA.java

import java.security.*;
import java.security.*;
import javax.crypto.*;
import java.io.*;
    
public class RSA {
	
	public static void main(String[] args) {
		
		try {
			
			System.out.println("RSA");
			String message="Combinazione: 123456";
			System.out.println("\nMessaggio: \n"+message);
			KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance("RSA");
			keyPairGenerator.initialize(1024);
			KeyPair keyPair = keyPairGenerator.genKeyPair();
			
			Cipher cipher = Cipher.getInstance("RSA/ECB/PKCS1Padding");
			cipher.init(Cipher.ENCRYPT_MODE, keyPair.getPublic());
			
			byte[] messageBytes = new String(message).getBytes("UTF8");	  
			byte[] cipherText = cipher.doFinal(messageBytes);
			
			String msgEncrypted = new String(cipherText);
			System.out.println("\nMessaggio cifrato: \n"+msgEncrypted);
			   
			cipher.init(Cipher.DECRYPT_MODE, keyPair.getPrivate());  
			byte[] decryptedMessageBytes = cipher.doFinal(cipherText);
			
			String msgDecrypted = new String(decryptedMessageBytes);
			System.out.println("\nMessaggio decifrato: \n"+msgDecrypted);
			
		}
		
		catch (NoSuchAlgorithmException e1) {		
			System.out.println("Algoritmo non supportato");
			System.exit(1);		
		
		}
	
		catch (NoSuchPaddingException e2) {		
			System.out.println("Padding non supportato");
			System.exit(2);		
		}
		
		catch (InvalidKeyException e3) {
			System.out.println("Chiave non valida");
			System.exit(3);	
		}
		
		catch (IllegalBlockSizeException e4) {
			System.out.println("Dimensione blocco illegale");
			System.exit(4);
		}
		
		catch (BadPaddingException e5) {
			System.out.println("Bad Padding");
			System.exit(5);
		}
				
		catch (UnsupportedEncodingException e6) {
			System.out.println("Codifica non supportata");
			System.exit(6);
		}
		
	}
}



