// Rijndael.java

import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import java.io.*;

public class Rijndael {
	
  	public static void main (String[] args) {

		System.out.println("RIJNDAEL");
		String text = "Hello world!";
	    if (args.length == 1) text = args[0];
	    System.out.println("\nTEXT:\n"+text);
    
	    try { 
	    	
		    KeyGenerator keyGenerator = KeyGenerator.getInstance("Rijndael");
		    keyGenerator.init(128);
		    Key key = keyGenerator.generateKey();
		  
		   	Cipher cipher = Cipher.getInstance("Rijndael/CBC/PKCS5Padding");
			
			SecureRandom random = new SecureRandom();
			byte[] iv = new byte[16];
			random.nextBytes(iv);
			IvParameterSpec spec = new IvParameterSpec(iv);
			
			cipher.init(Cipher.ENCRYPT_MODE, key, spec);
			
		    byte[ ] plaintext = text.getBytes("UTF8");
		    System.out.println("\nPLAINTEXT:");
		    for (int i=0;i<plaintext.length;i++) System.out.print(plaintext[i]+" ");
		    
		    byte[ ] ciphertext = cipher.doFinal(plaintext);
			System.out.println("\n\nCIPHERTEXT:");
		    for (int i=0;i<ciphertext.length;i++) System.out.print(ciphertext[i]+" ");
		
		    cipher.init(Cipher.DECRYPT_MODE, key, spec);
			byte[ ] decryptedText = cipher.doFinal(ciphertext);
		    String output = new String(decryptedText,"UTF8");
		    System.out.println("\n\nDECRYPTED TEXT:\n"+output); 
		    
		} 
		
		catch (NoSuchAlgorithmException e1) {		
			System.out.println("Algoritmo non supportato");
			System.exit(1);		
		}
		
		catch (InvalidAlgorithmParameterException e2) {
			System.out.println("Parametro non valido");
			System.exit(2);	
		}
	
		catch (NoSuchPaddingException e3) {		
			System.out.println("Padding non supportato");
			System.exit(3);		
		}
		
		catch (InvalidKeyException e4) {
			System.out.println("Chiave non valida");
			System.exit(4);	
		}
		
		catch (IllegalBlockSizeException e5) {
			System.out.println("Dimensione blocco non corretta");
			System.exit(5);
		}
		
		catch (BadPaddingException e6) {
			System.out.println("Bad Padding");
			System.exit(6);
		}
				
		catch (UnsupportedEncodingException e7) {
			System.out.println("Codifica non supportata");
			System.exit(7);
		}

	}

}
