// SealedObjectExample.java

import java.io.*;
import javax.crypto.*;
import java.security.*;

public class SealedObjectExample {

   	public static void main (String[ ] args) {
   		System.out.println("SEALED OBJECT\n");
   		
		try {
	       	String secretMessage = "Ci vediamo domani alle 15 al bar Roma";
			System.out.println("Messaggio in chiaro: "+secretMessage);
			
	       	KeyGenerator keyGenerator = KeyGenerator.getInstance("Blowfish");
	
	       	Key key = keyGenerator.generateKey();
	       	Cipher cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
	       	cipher.init(Cipher.ENCRYPT_MODE, key);
	       	SealedObject so = new SealedObject(secretMessage, cipher);
			
			/* 
			..... oggetto sicuro per trasporto e memorizzazione
			*/ 
			
	       	String decryptedMessage = (String)so.getObject(key);
	       	System.out.println("\nMessaggio decifrato: "+decryptedMessage);
	    } 
		
		catch (IOException e1) {
			System.out.println("Eccezione di I/O");
			System.exit(1);
		}
		
		catch (NoSuchAlgorithmException e2) {		
			System.out.println("Algoritmo non supportato");
			System.exit(2);		
		}
	
		catch (NoSuchPaddingException e3) {		
			System.out.println("Padding non supportato");
			System.exit(3);		
		}
		
		catch (InvalidKeyException e4) {
			System.out.println("Chiave non valida");
			System.exit(4);	
		}
		
		catch (IllegalBlockSizeException e5) {
			System.out.println("Dimensione blocco illegale");
			System.exit(5);
		}
		
		catch (ClassNotFoundException e6) {
			System.out.println("Eccezione di I/O");
			System.exit(6);
		}
		
  	}
}
