// SessionKey.java
// Cifratura a chiave di sessione

import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;

public class SessionKey {

	public static void main(String[] args) {
		
		try {
			
			System.out.println("Cifratura a chiave di sessione - Blowfish");

			KeyGenerator keyGenerator = KeyGenerator.getInstance("Blowfish");
			keyGenerator.init(128);
			Key blowfishKey = keyGenerator.generateKey();
			
			KeyPairGenerator keyPairGenerator=KeyPairGenerator.getInstance("RSA");
			keyPairGenerator.initialize(1024);
			KeyPair keyPair = keyPairGenerator.genKeyPair();
			
			Cipher cipher = Cipher.getInstance("RSA/ECB/PKCS1Padding");
			cipher.init(Cipher.ENCRYPT_MODE, keyPair.getPublic());
			byte[ ] blowfishKeyBytes = blowfishKey.getEncoded();
			byte[ ] cipherText = cipher.doFinal(blowfishKeyBytes);
			
			// ......
			// comunicazione della chiave di sessione al destinatario ...
			// ......
			
			cipher.init(Cipher.DECRYPT_MODE, keyPair.getPrivate());
			byte[ ] decryptedKeyBytes = cipher.doFinal(cipherText);
			SecretKey BlowfishKey = new SecretKeySpec(decryptedKeyBytes, "Blowfish");
		}
		
		catch (NoSuchAlgorithmException e1) {		
			System.out.println("Algoritmo non supportato");
			System.exit(1);		
		
		}
	
		catch (NoSuchPaddingException e2) {		
			System.out.println("Padding non supportato");
			System.exit(2);		
		}
		
		catch (InvalidKeyException e3) {
			System.out.println("Chiave non valida");
			System.exit(3);	
		}
		
		catch (IllegalBlockSizeException e4) {
			System.out.println("Dimensione blocco illegale");
			System.exit(4);
		}
		
		catch (BadPaddingException e5) {
			System.out.println("Bad Padding");
			System.exit(5);
		}
				
	}  
}                         
