// SignRSA.java
// Firma e verifica con RSA

import java.security.*;
import javax.crypto.*;
import java.io.*;

public class SignRSA {
	
	public static void main(String[] args) {
		
		try {

			System.out.println("Firma digitale con RSA\n");
			
			KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
			kpg.initialize(1024);
			KeyPair keyPair = kpg.genKeyPair();
			  
			byte[] messaggio = new String("non ci sono pi le mezze stagioni").getBytes("UTF8");
			
			Signature sig = Signature.getInstance("MD5WithRSA");
			sig.initSign(keyPair.getPrivate());  
			sig.update(messaggio);
			
			byte[] signatureBytes = sig.sign();
			
			sig.initVerify(keyPair.getPublic());
			sig.update(messaggio);
			
			boolean verified = false;
			verified = sig.verify(signatureBytes);	
			if(verified) {
				System.out.println("\nMessaggio valido");
			}
			else  {
				System.out.println("\nMessaggio non valido");
			}
			
		}
		
		catch (SignatureException e1) { 
			System.out.println("La firma ha un formato non valido! ");
			System.exit(1);	
		}
		
		catch (NoSuchAlgorithmException e1) {		
			System.out.println("Algoritmo non supportato");
			System.exit(2);		
		}
		
		catch (InvalidKeyException e3) {
			System.out.println("Chiave non valida");
			System.exit(3);	
		}
		
		catch (UnsupportedEncodingException e4) {
			System.out.println("Codifica non supportata");
			System.exit(4);	
		}
		
	}
	
}



