// TDES_PBE.java	
// PBE (file PBE2) usato per cifrare la chiave simmetrica generata con TDES
// nelle modalit WRAP_MODE e UNWRAP_MODE	

import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import java.io.*;

public class TDES_PBE {
	
  	public static void main (String[] args) {

		System.out.println("TRIPLE DES e PBE");
		String text;
		char[] password; // per cifrare la chiave da memorizzare
	    if (args.length != 2) {
	    	String pwd="password";	
			password=new char[pwd.length()];
			pwd.getChars(0,pwd.length(),password,0);
			text="Hello World!";
		}
	    else {
			password=new char[args[0].length()];
			args[0].getChars(0,args[0].length(),password,0);
			text=args[1];
		}
	    System.out.println("\nTEXT:\n"+text);
    
	    try { 
	    	
		    KeyGenerator keyGenerator = KeyGenerator.getInstance("TripleDES");
		    keyGenerator.init(168);	// 3 key 56bit (+8bit control)
		    Key key = keyGenerator.generateKey();
		  
		   	Cipher cipher = Cipher.getInstance("TripleDES/ECB/PKCS5Padding");
		    cipher.init(Cipher.ENCRYPT_MODE, key);
		
		    byte[] plaintext = text.getBytes("UTF8");
		    System.out.println("\nPLAINTEXT:");
		    for (int i=0;i<plaintext.length;i++) System.out.print(plaintext[i]+" ");
		    
		    byte[] ciphertext = cipher.doFinal(plaintext);
			System.out.println("\n\nCIPHERTEXT:");
		    for (int i=0;i<ciphertext.length;i++) System.out.print(ciphertext[i]+" ");
		      
		    //Cifratura della chiave con PBE
			byte[] keyEncrypted = PBE2.encrypt(password, key);
			
			//.....
			
			//Decifratura della chiave con PBE
			Key myKey = (SecretKey)PBE2.decrypt(password, keyEncrypted); 
	
		    cipher.init(Cipher.DECRYPT_MODE, myKey);
			byte[] decryptedText = cipher.doFinal(ciphertext);
		    String output = new String(decryptedText,"UTF8");
		    System.out.println("\n\nDECRYPTED TEXT:\n"+output); 
		    
		} 
		
		catch (NoSuchAlgorithmException e1) {		
			System.out.println("Algoritmo non supportato");
			System.exit(1);		
		}
	
		catch (NoSuchPaddingException e2) {		
			System.out.println("Padding non supportato");
			System.exit(2);		
		}
		
		catch (InvalidKeyException e3) {
			System.out.println("Chiave non valida");
			System.exit(3);	
		}
		
		catch (IllegalBlockSizeException e4) {
			System.out.println("Dimensione blocco illegale");
			System.exit(4);
		}
		
		catch (BadPaddingException e5) {
			System.out.println("Bad Padding");
			System.exit(5);
		}
				
		catch (UnsupportedEncodingException e6) {
			System.out.println("Codifica non supportata");
			System.exit(6);
		}

	}

}