import java.net.*;
import java.io.*;

/* 
 * This example illustrates using a URL to access resources
 * on a secure site from behind the firewall using the SSLTunnelSocketFactory.
 * 
 */

public class URLTunnelReader {
   private final static String proxyHost = "proxy.sg.ibm.com";
   private final static String proxyPort = "80";
   
   public static void main(String[] args) throws Exception {
      System.setProperty("java.protocol.handler.pkgs",
                         "com.sun.net.ssl.internal.www.protocol");
      System.setProperty("https.proxyHost",proxyHost);
      System.setProperty("https.proxyPort",proxyPort);
      
      URL verisign = new URL("https://www.verisign.com");
      URLConnection urlc = verisign.openConnection(); //from secure site
      if(urlc instanceof com.sun.net.ssl.HttpsURLConnection){
         ((com.sun.net.ssl.HttpsURLConnection)urlc).setSSLSocketFactory
                           (new SSLTunnelSocketFactory(proxyHost,proxyPort));
      }
      
      BufferedReader in = new BufferedReader(new InputStreamReader(
                                             urlc.getInputStream()));
      
      String inputLine;
      
      while ((inputLine = in.readLine()) != null)
         System.out.println(inputLine);
      
      in.close();
   }
}
